/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.pricing;

import com.rjconsultores.ventaboletos.entidad.Categoria;
import com.rjconsultores.ventaboletos.entidad.Pricing;
import com.rjconsultores.ventaboletos.entidad.PricingCategoria;
import com.rjconsultores.ventaboletos.service.CategoriaService;
import com.rjconsultores.ventaboletos.service.PricingCategoriaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import java.util.Calendar;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import java.util.List;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Combobox;

/**
 *
 * @author Rafius
 */
@Controller("editarPricingCategoriaController")
@Scope("prototype")
public class EditarPricingCategoriaController extends MyGenericForwardComposer {

    @Autowired
    private PricingCategoriaService pricingCategoriaService;
    @Autowired
    private CategoriaService categoriaService;
    private List<Categoria> lsCategoria;
    private PricingCategoria pricingCategoria;
    private MyListbox pricingCategoriaList;
    private Combobox cmbCategoria;
    private static Logger log = Logger.getLogger(EditarPricingCategoriaController.class);

    @Override
    public void doAfterCompose(Component comp) throws Exception {

        lsCategoria = categoriaService.obtenerTodos();

        pricingCategoria = (PricingCategoria) Executions.getCurrent().getArg().get("pricingCategoria");
        pricingCategoriaList = (MyListbox) Executions.getCurrent().getArg().get("pricingCategoriaList");

        super.doAfterCompose(comp);

        cmbCategoria.focus();

    }

    public void onClick$btnAdicionarCategoria(Event ev) throws Exception {
        cmbCategoria.getValue();
        try {
            if (pricingCategoria.getCategoria() == null) {
                Messagebox.show(
                        Labels.getLabel("MSG.Error.combobox"),
                        Labels.getLabel("editarPricingController.windowCategoria.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            } else {
                Boolean existe = pricingCategoriaService.obtenerPricingCategoria(pricingCategoria.getPricing(), (Categoria) cmbCategoria.getSelectedItem().getValue());

                if (existe) {
                    Messagebox.show(
                            Labels.getLabel("MSG.Registro.Existe"),
                            Labels.getLabel("editarPricingController.windowCategoria.title"),
                            Messagebox.OK, Messagebox.EXCLAMATION);
                } else {
                    if (pricingCategoria.getPricingcategoriaId() != null) {
                        pricingCategoriaService.actualizacion(pricingCategoria);
                        pricingCategoriaList.updateItem(pricingCategoria);
                    } else {
                        pricingCategoriaService.suscribir(pricingCategoria);
                        pricingCategoriaList.addItem(pricingCategoria);
                    }
                    closeWindow();
                }
            }
        } catch (Exception ex) {
            log.error("Erro ao adicionar categoria: " + ex);
        }
    }

    public void onClick$btnRemoverCategoria(Event ev) {
        try {
            PricingCategoria pCategoria = (PricingCategoria) pricingCategoriaList.getSelected();
            if (pCategoria != null) {
                int resp = Messagebox.show(
                        Labels.getLabel("editarPricingController.MSG.borrarPerguntaCategoria"),
                        Labels.getLabel("editarPricingController.windowCategoria.title"),
                        Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

                if (resp == Messagebox.YES) {
                    pricingCategoria.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                    pricingCategoria.setFecmodif(Calendar.getInstance().getTime());
                    pricingCategoria.setActivo(Pricing.INATIVO);

                    pricingCategoriaList.removeItem(pricingCategoria);
                    pricingCategoriaService.borrar(pricingCategoria);
                    closeWindow();
                }
            } else {
                Messagebox.show(
                        Labels.getLabel("editarPricingController.MSG.selectItem"),
                        Labels.getLabel("editarPricingController.windowCategoria.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            }
        } catch (Exception ex) {
            log.error("Erro ao remover categoria: " + ex);
        }

    }

    public PricingCategoria getPricingCategoria() {
        return pricingCategoria;
    }

    public void setPricingCategoria(PricingCategoria pricingCategoria) {
        this.pricingCategoria = pricingCategoria;
    }

    public MyListbox getPricingCategoriaList() {
        return pricingCategoriaList;
    }

    public void setPricingCategoriaList(MyListbox pricingCategoriaList) {
        this.pricingCategoriaList = pricingCategoriaList;
    }

    public PricingCategoriaService getPricingCategoriaService() {
        return pricingCategoriaService;
    }

    public void setPricingCategoriaService(PricingCategoriaService pricingCategoriaService) {
        this.pricingCategoriaService = pricingCategoriaService;
    }

    public List<Categoria> getLsCategoria() {
        return lsCategoria;
    }

    public void setLsCategoria(List<Categoria> lsCategoria) {
        this.lsCategoria = lsCategoria;
    }

    public CategoriaService getCategoriaService() {
        return categoriaService;
    }

    public void setCategoriaService(CategoriaService categoriaService) {
        this.categoriaService = categoriaService;
    }
}
